
#include "MacroPatternMatch.h"

#include "HROOTHistTF1.h"

#include "HROOTHistTH1F.h"

#include "HROOTHistTAxis.h"

#include "HROOTCoreTNamed.h"

#include "HROOTCoreTAttLine.h"

#include "HROOTCoreTAttFill.h"

#include "HROOTCoreTAttMarker.h"

#include "TGraph.h"

#include "HROOTHistTGraph.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TNAMED_DEF_VIRT(TGraph)
TATTLINE_DEF_VIRT(TGraph)
TATTFILL_DEF_VIRT(TGraph)
TATTMARKER_DEF_VIRT(TGraph)
TOBJECT_DEF_VIRT(TGraph)
DELETABLE_DEF_VIRT(TGraph)
TGRAPH_DEF_VIRT(TGraph)
TGRAPH_DEF_NONVIRT(TGraph)
TGRAPH_DEF_ACCESSOR(TGraph)

