{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Hist.TMultiGraph.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Hist.TMultiGraph.RawType
import HROOT.Core.TNamed.Interface
import HROOT.Hist.TGraph.Interface

class (ITNamed a) => ITMultiGraph a where
        addG ::
               (Castable c1 CString, ITGraph c0, FPtr c0) =>
               a -> c0 -> c1 -> IO ()

upcastTMultiGraph ::
                  forall a . (FPtr a, ITMultiGraph a) => a -> TMultiGraph
upcastTMultiGraph h
  = let fh = get_fptr h
        fh2 :: Ptr RawTMultiGraph = castPtr fh
      in cast_fptr_to_obj fh2

downcastTMultiGraph ::
                    forall a . (FPtr a, ITMultiGraph a) => TMultiGraph -> a
downcastTMultiGraph h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
