
#include "MacroPatternMatch.h"

#include "HROOTHistTH1.h"

#include "HROOTCoreTArrayS.h"

#include "TH1S.h"

#include "HROOTHistTH1S.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TH1_DEF_VIRT(TH1S)
TARRAYS_DEF_VIRT(TH1S)
TNAMED_DEF_VIRT(TH1S)
TATTLINE_DEF_VIRT(TH1S)
TATTFILL_DEF_VIRT(TH1S)
TATTMARKER_DEF_VIRT(TH1S)
TOBJECT_DEF_VIRT(TH1S)
DELETABLE_DEF_VIRT(TH1S)
TARRAY_DEF_VIRT(TH1S)
TH1S_DEF_VIRT(TH1S)
TH1S_DEF_NONVIRT(TH1S)
TH1S_DEF_ACCESSOR(TH1S)

