{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Hist.TMultiGraph.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Hist.TMultiGraph.RawType
import HROOT.Hist.TMultiGraph.FFI
import HROOT.Hist.TMultiGraph.Interface
import HROOT.Hist.TMultiGraph.Cast
import HROOT.Hist.TMultiGraph.RawType
import HROOT.Hist.TMultiGraph.Cast
import HROOT.Hist.TMultiGraph.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Hist.TGraph.RawType
import HROOT.Hist.TGraph.Cast
import HROOT.Hist.TGraph.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITMultiGraph (TMultiGraph) where
        addG = xform2 c_tmultigraph_addg

instance () => ITNamed (TMultiGraph) where
        setName = xform1 c_tmultigraph_setname
        setNameTitle = xform2 c_tmultigraph_setnametitle
        setTitle = xform1 c_tmultigraph_settitle

instance () => ITObject (TMultiGraph) where
        clear = xform1 c_tmultigraph_clear
        draw = xform1 c_tmultigraph_draw
        findObject = xform1 c_tmultigraph_findobject
        getName = xform0 c_tmultigraph_getname
        isA = xform0 c_tmultigraph_isa
        paint = xform1 c_tmultigraph_paint
        printObj = xform1 c_tmultigraph_printobj
        saveAs = xform2 c_tmultigraph_saveas
        write = xform3 c_tmultigraph_write
        write_ = xform0 c_tmultigraph_write_

instance () => IDeletable (TMultiGraph) where
        delete = xform0 c_tmultigraph_delete

newTMultiGraph ::
                 (Castable c1 CString, Castable c0 CString) =>
                 c0 -> c1 -> IO TMultiGraph
newTMultiGraph = xform1 c_tmultigraph_newtmultigraph
